import { useCallback, useEffect, useRef, useState } from 'react';
// todo: provide start timestamp
export var useTimeElapsed = function (_a) {
    var _b = _a === void 0 ? {} : _a, startOnMount = _b.startOnMount;
    var _c = useState(0), secondsElapsed = _c[0], setSecondsElapsed = _c[1];
    var updateInterval = useRef();
    var startCounter = useCallback(function () {
        if (updateInterval.current)
            return;
        updateInterval.current = setInterval(function () {
            setSecondsElapsed(function (prev) { return prev + 1; });
        }, 1000);
    }, []);
    var stopCounter = useCallback(function () {
        clearInterval(updateInterval.current);
        updateInterval.current = undefined;
    }, []);
    useEffect(function () {
        if (!startOnMount)
            return;
        startCounter();
        return function () {
            stopCounter();
        };
    }, [startCounter, startOnMount, stopCounter]);
    return {
        secondsElapsed: secondsElapsed,
        startCounter: startCounter,
        stopCounter: stopCounter,
    };
};
