import { GroupStyle, ProcessMessagesParams } from '../../utils';
import type { Channel } from 'stream-chat';
import type { StreamMessage } from '../../../../context/ChannelStateContext';
import type { DefaultStreamChatGenerics } from '../../../../types/types';
export declare const useEnrichedMessages: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>(args: {
    channel: Channel<StreamChatGenerics>;
    disableDateSeparator: boolean;
    hideDeletedMessages: boolean;
    hideNewMessageSeparator: boolean;
    messages: StreamMessage<StreamChatGenerics>[];
    noGroupByUser: boolean;
    groupStyles?: ((message: StreamMessage<StreamChatGenerics>, previousMessage: StreamMessage<StreamChatGenerics>, nextMessage: StreamMessage<StreamChatGenerics>, noGroupByUser: boolean, maxTimeBetweenGroupedMessages?: number) => GroupStyle) | undefined;
    headerPosition?: number | undefined;
    maxTimeBetweenGroupedMessages?: number | undefined;
    reviewProcessedMessage?: ((params: {
        changes: StreamMessage<StreamChatGenerics>[];
        context: {
            userId: string;
            enableDateSeparator?: boolean | undefined;
            hideDeletedMessages?: boolean | undefined;
            hideNewMessageSeparator?: boolean | undefined;
            lastRead?: Date | null | undefined;
        };
        index: number;
        messages: StreamMessage<StreamChatGenerics>[];
        processedMessages: StreamMessage<StreamChatGenerics>[];
    }) => StreamMessage<StreamChatGenerics>[]) | undefined;
}) => {
    messageGroupStyles: Record<string, GroupStyle>;
    messages: StreamMessage<StreamChatGenerics>[];
};
//# sourceMappingURL=useEnrichedMessages.d.ts.map